Deleted Added
full compact
jib (295553) jib (295554)
1#!/bin/sh
2#-
3# Copyright (c) 2016 Devin Teske
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10# notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12# notice, this list of conditions and the following disclaimer in the
13# documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
1#!/bin/sh
2#-
3# Copyright (c) 2016 Devin Teske
4# All rights reserved.
5#
6# Redistribution and use in source and binary forms, with or without
7# modification, are permitted provided that the following conditions
8# are met:
9# 1. Redistributions of source code must retain the above copyright
10# notice, this list of conditions and the following disclaimer.
11# 2. Redistributions in binary form must reproduce the above copyright
12# notice, this list of conditions and the following disclaimer in the
13# documentation and/or other materials provided with the distribution.
14#
15# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
16# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
17# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
18# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
19# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
20# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
21# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
22# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
23# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
24# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
25# SUCH DAMAGE.
26#
27# $FreeBSD: head/share/examples/jails/jib 295553 2016-02-12 01:12:44Z dteske $
27# $FreeBSD: head/share/examples/jails/jib 295554 2016-02-12 01:41:40Z dteske $
28#
29############################################################ IDENT(1)
30#
31# $Title: if_bridge(4) management script for vnet jails $
32#
33############################################################ INFORMATION
34#
35# Use this tool with jail.conf(5) (or rc.conf(5) ``legacy'' configuration) to
36# manage `vnet' interfaces for jails. Designed to automate the creation of vnet
37# interface(s) during jail `prestart' and destroy said interface(s) during jail
38# `poststop'.
39#
40# In jail.conf(5) format:
41#
42# ### BEGIN EXCERPT ###
43#
44# xxx {
45# host.hostname = "xxx.yyy";
46# path = "/vm/xxx";
47#
48# #
49# # NB: Below 2-lines required
50# # NB: The number of eNb_xxx interfaces should match the number of
51# # arguments given to `jib addm xxx' in exec.prestart value.
52# #
53# vnet;
54# vnet.interface = "e0b_xxx e1b_xxx ...";
55#
56# exec.clean;
57# exec.system_user = "root";
58# exec.jail_user = "root";
59#
60# #
61# # NB: Below 2-lines required
62# # NB: The number of arguments after `jib addm xxx' should match
63# # the number of eNb_xxx arguments in vnet.interface value.
64# #
65# exec.prestart += "jib addm xxx em0 em1 ...";
66# exec.poststop += "jib destroy xxx";
67#
68# # Standard recipe
69# exec.start += "/bin/sh /etc/rc";
70# exec.stop = "/bin/sh /etc/rc.shutdown";
71# exec.consolelog = "/var/log/jail_xxx_console.log";
72# mount.devfs;
73#
74# # Optional (default off)
75# #allow.mount;
76# #allow.set_hostname = 1;
77# #allow.sysvipc = 1;
78# #devfs_ruleset = "11"; # rule to unhide bpf for DHCP
79# }
80#
81# ### END EXCERPT ###
82#
83# In rc.conf(5) ``legacy'' format (used when /etc/jail.conf does not exist):
84#
85# ### BEGIN EXCERPT ###
86#
87# jail_enable="YES"
88# jail_list="xxx"
89#
90# #
91# # Global presets for all jails
92# #
93# jail_devfs_enable="YES" # mount devfs
94#
95# #
96# # Global options (default off)
97# #
98# #jail_mount_enable="YES" # mount /etc/fstab.{name}
99# #jail_set_hostname_allow="YES" # Allow hostname to change
100# #jail_sysvipc_allow="YES" # Allow SysV Interprocess Comm.
101#
102# # xxx
103# jail_xxx_hostname="xxx.shxd.cx" # hostname
104# jail_xxx_rootdir="/vm/xxx" # root directory
105# jail_xxx_vnet_interfaces="e0b_xxx e1bxxx ..." # vnet interface(s)
106# jail_xxx_exec_prestart0="jib addm xxx em0 em1 ..." # bridge interface(s)
107# jail_xxx_exec_poststop0="jib destroy xxx" # destroy interface(s)
108# #jail_xxx_mount_enable="YES" # mount /etc/fstab.xxx
109# #jail_xxx_devfs_ruleset="11" # rule to unhide bpf for DHCP
110#
111# ### END EXCERPT ###
112#
113# Note that the legacy rc.conf(5) format is converted to
114# /var/run/jail.{name}.conf by /etc/rc.d/jail if jail.conf(5) is missing.
115#
116# ASIDE: dhclient(8) inside a vnet jail...
117#
118# To allow dhclient(8) to work inside a vnet jail, make sure the following
119# appears in /etc/devfs.rules (which should be created if it doesn't exist):
120#
121# [devfsrules_jail=11]
122# add include $devfsrules_hide_all
123# add include $devfsrules_unhide_basic
124# add include $devfsrules_unhide_login
125# add path 'bpf*' unhide
126#
127# And set ether devfs.ruleset="11" (jail.conf(5)) or
128# jail_{name}_devfs_ruleset="11" (rc.conf(5)).
129#
130# NB: While this tool can't create every type of desirable topology, it should
131# handle most setups, minus some which considered exotic or purpose-built.
132#
133############################################################ GLOBALS
134
135pgm="${0##*/}" # Program basename
136
137#
138# Global exit status
139#
140SUCCESS=0
141FAILURE=1
142
143############################################################ FUNCTIONS
144
145usage()
146{
147 local action usage descr
148 exec >&2
149 echo "Usage: $pgm action [arguments]"
150 echo "Actions:"
151 for action in \
152 addm \
153 show \
154 show1 \
155 destroy \
156 ; do
157 eval usage=\"\$jib_${action}_usage\"
158 [ "$usage" ] || continue
159 eval descr=\"\$jib_${action}_descr\"
160 printf "\t%s\n\t\t%s\n" "$usage" "$descr"
161 done
162 exit $FAILURE
163}
164
165action_usage()
166{
167 local usage action="$1"
168 eval usage=\"\$jib_${action}_usage\"
169 echo "Usage: $pgm $usage" >&2
170 exit $FAILURE
171}
172
173derive_mac()
174{
175 local OPTIND=1 OPTARG __flag
176 local __mac_num= __make_pair=
177 while getopts 2n: __flag; do
178 case "$__flag" in
179 2) __make_pair=1 ;;
180 n) __mac_num=${OPTARG%%[^0-9]*} ;;
181 esac
182 done
183 shift $(( $OPTIND - 1 ))
184
185 if [ ! "$__mac_num" ]; then
186 eval __mac_num=\${_${iface}_num:--1}
187 __mac_num=$(( $__mac_num + 1 ))
188 eval _${iface}_num=\$__mac_num
189 fi
190
191 local __iface="$1" __name="$2" __var_to_set="$3" __var_to_set_b="$4"
192 local __iface_devid __new_devid __num __new_devid_b
193 #
194 # Calculate MAC address derived from given iface.
195 #
196 # The formula I'm using is ``NP:SS:SS:II:II:II'' where:
197 # + N denotes 4 bits used as a counter to support branching
198 # each parent interface up to 15 times under the same jail
199 # name (see S below).
200 # + P denotes the special nibble whose value, if one of
201 # 2, 6, A, or E (but usually 2) denotes a privately
202 # administered MAC address (while remaining routable).
203 # + S denotes 16 bits, the sum(1) value of the jail name.
204 # + I denotes bits that are inherited from parent interface.
205 #
206 # The S bits are a CRC-16 checksum of NAME, allowing the jail
207 # to change link numbers in ng_bridge(4) without affecting the
208 # MAC address. Meanwhile, if...
209 # + the jail NAME changes (e.g., it was duplicated and given
210 # a new name with no other changes)
211 # + the underlying network interface changes
212 # + the jail is moved to another host
213 # the MAC address will be recalculated to a new, similarly
214 # unique value preventing conflict.
215 #
216 __iface_devid=$( ifconfig $__iface ether | awk '/ether/,$0=$2' )
217 # ??:??:??:II:II:II
218 __new_devid=${__iface_devid#??:??:??} # => :II:II:II
219 # => :SS:SS:II:II:II
220 __num=$( set -- `echo -n "$__name" | sum` && echo $1 )
221 __new_devid=$( printf :%02x:%02x \
222 $(( $__num >> 8 & 255 )) $(( $__num & 255 )) )$__new_devid
223 # => P:SS:SS:II:II:II
224 case "$__iface_devid" in
225 ?2:*) __new_devid=a$__new_devid __new_devid_b=e$__new_devid ;;
226 ?[Ee]:*) __new_devid=2$__new_devid __new_devid_b=6$__new_devid ;;
227 *) __new_devid=2$__new_devid __new_devid_b=e$__new_devid
228 esac
229 # => NP:SS:SS:II:II:II
230 __new_devid=$( printf %x $(( $__mac_num & 15 )) )$__new_devid
231 __new_devid_b=$( printf %x $(( $__mac_num & 15 )) )$__new_devid_b
232
233 #
234 # Return derivative MAC address(es)
235 #
236 if [ "$__make_pair" ]; then
237 if [ "$__var_to_set" -a "$__var_to_set_b" ]; then
238 eval $__var_to_set=\$__new_devid
239 eval $__var_to_set_b=\$__new_devid_b
240 else
241 echo $__new_devid $__new_devid_b
242 fi
243 else
244 if [ "$__var_to_set" ]; then
245 eval $__var_to_set=\$__new_devid
246 else
247 echo $__new_devid
248 fi
249 fi
250}
251
252mustberoot_to_continue()
253{
254 if [ "$( id -u )" -ne 0 ]; then
255 echo "Must run as root!" >&2
256 exit $FAILURE
257 fi
258}
259
28#
29############################################################ IDENT(1)
30#
31# $Title: if_bridge(4) management script for vnet jails $
32#
33############################################################ INFORMATION
34#
35# Use this tool with jail.conf(5) (or rc.conf(5) ``legacy'' configuration) to
36# manage `vnet' interfaces for jails. Designed to automate the creation of vnet
37# interface(s) during jail `prestart' and destroy said interface(s) during jail
38# `poststop'.
39#
40# In jail.conf(5) format:
41#
42# ### BEGIN EXCERPT ###
43#
44# xxx {
45# host.hostname = "xxx.yyy";
46# path = "/vm/xxx";
47#
48# #
49# # NB: Below 2-lines required
50# # NB: The number of eNb_xxx interfaces should match the number of
51# # arguments given to `jib addm xxx' in exec.prestart value.
52# #
53# vnet;
54# vnet.interface = "e0b_xxx e1b_xxx ...";
55#
56# exec.clean;
57# exec.system_user = "root";
58# exec.jail_user = "root";
59#
60# #
61# # NB: Below 2-lines required
62# # NB: The number of arguments after `jib addm xxx' should match
63# # the number of eNb_xxx arguments in vnet.interface value.
64# #
65# exec.prestart += "jib addm xxx em0 em1 ...";
66# exec.poststop += "jib destroy xxx";
67#
68# # Standard recipe
69# exec.start += "/bin/sh /etc/rc";
70# exec.stop = "/bin/sh /etc/rc.shutdown";
71# exec.consolelog = "/var/log/jail_xxx_console.log";
72# mount.devfs;
73#
74# # Optional (default off)
75# #allow.mount;
76# #allow.set_hostname = 1;
77# #allow.sysvipc = 1;
78# #devfs_ruleset = "11"; # rule to unhide bpf for DHCP
79# }
80#
81# ### END EXCERPT ###
82#
83# In rc.conf(5) ``legacy'' format (used when /etc/jail.conf does not exist):
84#
85# ### BEGIN EXCERPT ###
86#
87# jail_enable="YES"
88# jail_list="xxx"
89#
90# #
91# # Global presets for all jails
92# #
93# jail_devfs_enable="YES" # mount devfs
94#
95# #
96# # Global options (default off)
97# #
98# #jail_mount_enable="YES" # mount /etc/fstab.{name}
99# #jail_set_hostname_allow="YES" # Allow hostname to change
100# #jail_sysvipc_allow="YES" # Allow SysV Interprocess Comm.
101#
102# # xxx
103# jail_xxx_hostname="xxx.shxd.cx" # hostname
104# jail_xxx_rootdir="/vm/xxx" # root directory
105# jail_xxx_vnet_interfaces="e0b_xxx e1bxxx ..." # vnet interface(s)
106# jail_xxx_exec_prestart0="jib addm xxx em0 em1 ..." # bridge interface(s)
107# jail_xxx_exec_poststop0="jib destroy xxx" # destroy interface(s)
108# #jail_xxx_mount_enable="YES" # mount /etc/fstab.xxx
109# #jail_xxx_devfs_ruleset="11" # rule to unhide bpf for DHCP
110#
111# ### END EXCERPT ###
112#
113# Note that the legacy rc.conf(5) format is converted to
114# /var/run/jail.{name}.conf by /etc/rc.d/jail if jail.conf(5) is missing.
115#
116# ASIDE: dhclient(8) inside a vnet jail...
117#
118# To allow dhclient(8) to work inside a vnet jail, make sure the following
119# appears in /etc/devfs.rules (which should be created if it doesn't exist):
120#
121# [devfsrules_jail=11]
122# add include $devfsrules_hide_all
123# add include $devfsrules_unhide_basic
124# add include $devfsrules_unhide_login
125# add path 'bpf*' unhide
126#
127# And set ether devfs.ruleset="11" (jail.conf(5)) or
128# jail_{name}_devfs_ruleset="11" (rc.conf(5)).
129#
130# NB: While this tool can't create every type of desirable topology, it should
131# handle most setups, minus some which considered exotic or purpose-built.
132#
133############################################################ GLOBALS
134
135pgm="${0##*/}" # Program basename
136
137#
138# Global exit status
139#
140SUCCESS=0
141FAILURE=1
142
143############################################################ FUNCTIONS
144
145usage()
146{
147 local action usage descr
148 exec >&2
149 echo "Usage: $pgm action [arguments]"
150 echo "Actions:"
151 for action in \
152 addm \
153 show \
154 show1 \
155 destroy \
156 ; do
157 eval usage=\"\$jib_${action}_usage\"
158 [ "$usage" ] || continue
159 eval descr=\"\$jib_${action}_descr\"
160 printf "\t%s\n\t\t%s\n" "$usage" "$descr"
161 done
162 exit $FAILURE
163}
164
165action_usage()
166{
167 local usage action="$1"
168 eval usage=\"\$jib_${action}_usage\"
169 echo "Usage: $pgm $usage" >&2
170 exit $FAILURE
171}
172
173derive_mac()
174{
175 local OPTIND=1 OPTARG __flag
176 local __mac_num= __make_pair=
177 while getopts 2n: __flag; do
178 case "$__flag" in
179 2) __make_pair=1 ;;
180 n) __mac_num=${OPTARG%%[^0-9]*} ;;
181 esac
182 done
183 shift $(( $OPTIND - 1 ))
184
185 if [ ! "$__mac_num" ]; then
186 eval __mac_num=\${_${iface}_num:--1}
187 __mac_num=$(( $__mac_num + 1 ))
188 eval _${iface}_num=\$__mac_num
189 fi
190
191 local __iface="$1" __name="$2" __var_to_set="$3" __var_to_set_b="$4"
192 local __iface_devid __new_devid __num __new_devid_b
193 #
194 # Calculate MAC address derived from given iface.
195 #
196 # The formula I'm using is ``NP:SS:SS:II:II:II'' where:
197 # + N denotes 4 bits used as a counter to support branching
198 # each parent interface up to 15 times under the same jail
199 # name (see S below).
200 # + P denotes the special nibble whose value, if one of
201 # 2, 6, A, or E (but usually 2) denotes a privately
202 # administered MAC address (while remaining routable).
203 # + S denotes 16 bits, the sum(1) value of the jail name.
204 # + I denotes bits that are inherited from parent interface.
205 #
206 # The S bits are a CRC-16 checksum of NAME, allowing the jail
207 # to change link numbers in ng_bridge(4) without affecting the
208 # MAC address. Meanwhile, if...
209 # + the jail NAME changes (e.g., it was duplicated and given
210 # a new name with no other changes)
211 # + the underlying network interface changes
212 # + the jail is moved to another host
213 # the MAC address will be recalculated to a new, similarly
214 # unique value preventing conflict.
215 #
216 __iface_devid=$( ifconfig $__iface ether | awk '/ether/,$0=$2' )
217 # ??:??:??:II:II:II
218 __new_devid=${__iface_devid#??:??:??} # => :II:II:II
219 # => :SS:SS:II:II:II
220 __num=$( set -- `echo -n "$__name" | sum` && echo $1 )
221 __new_devid=$( printf :%02x:%02x \
222 $(( $__num >> 8 & 255 )) $(( $__num & 255 )) )$__new_devid
223 # => P:SS:SS:II:II:II
224 case "$__iface_devid" in
225 ?2:*) __new_devid=a$__new_devid __new_devid_b=e$__new_devid ;;
226 ?[Ee]:*) __new_devid=2$__new_devid __new_devid_b=6$__new_devid ;;
227 *) __new_devid=2$__new_devid __new_devid_b=e$__new_devid
228 esac
229 # => NP:SS:SS:II:II:II
230 __new_devid=$( printf %x $(( $__mac_num & 15 )) )$__new_devid
231 __new_devid_b=$( printf %x $(( $__mac_num & 15 )) )$__new_devid_b
232
233 #
234 # Return derivative MAC address(es)
235 #
236 if [ "$__make_pair" ]; then
237 if [ "$__var_to_set" -a "$__var_to_set_b" ]; then
238 eval $__var_to_set=\$__new_devid
239 eval $__var_to_set_b=\$__new_devid_b
240 else
241 echo $__new_devid $__new_devid_b
242 fi
243 else
244 if [ "$__var_to_set" ]; then
245 eval $__var_to_set=\$__new_devid
246 else
247 echo $__new_devid
248 fi
249 fi
250}
251
252mustberoot_to_continue()
253{
254 if [ "$( id -u )" -ne 0 ]; then
255 echo "Must run as root!" >&2
256 exit $FAILURE
257 fi
258}
259
260jib_addm_usage="addm [-b BRIDGE_NAME] NAME interface0 [interface1 ...]"
260jib_addm_usage="addm [-b BRIDGE_NAME] NAME [!]iface0 [[!]iface1 ...]"
261jib_addm_descr="Creates e0b_NAME [e1b_NAME ...]"
262jib_addm()
263{
264 local OPTIND=1 OPTARG flag bridge=bridge
265 while getopts b: flag; do
266 case "$flag" in
267 b) bridge="${OPTARG:-bridge}" ;;
268 *) action_usage addm # NOTREACHED
269 esac
270 done
271 shift $(( $OPTIND - 1 ))
272
273 local name="$1"
274 [ "${name:-x}" = "${name#*[!0-9a-zA-Z_]}" -a $# -gt 1 ] ||
275 action_usage addm # NOTREACHED
276 shift 1 # name
277
278 mustberoot_to_continue
279
280 local iface eiface_devid_a eiface_devid_b
261jib_addm_descr="Creates e0b_NAME [e1b_NAME ...]"
262jib_addm()
263{
264 local OPTIND=1 OPTARG flag bridge=bridge
265 while getopts b: flag; do
266 case "$flag" in
267 b) bridge="${OPTARG:-bridge}" ;;
268 *) action_usage addm # NOTREACHED
269 esac
270 done
271 shift $(( $OPTIND - 1 ))
272
273 local name="$1"
274 [ "${name:-x}" = "${name#*[!0-9a-zA-Z_]}" -a $# -gt 1 ] ||
275 action_usage addm # NOTREACHED
276 shift 1 # name
277
278 mustberoot_to_continue
279
280 local iface eiface_devid_a eiface_devid_b
281 local new num quad i=0
281 local new no_derive num quad i=0
282 for iface in $*; do
283
282 for iface in $*; do
283
284 no_derive=
285 case "$iface" in
286 !*) iface=${iface#!} no_derive=1 ;;
287 esac
288
284 # 1. Make sure the interface doesn't exist already
285 ifconfig "e${i}a_$name" > /dev/null 2>&1 && continue
286
287 # 2. Bring the interface up
288 ifconfig $iface up || return
289
290 # 3. Make sure the interface has been bridged
291 if ! ifconfig "$iface$bridge" > /dev/null 2>&1; then
292 new=$( ifconfig bridge create ) || return
293 ifconfig $new addm $iface || return
294 ifconfig $new name "$iface$bridge" || return
295 ifconfig "$iface$bridge" up || return
296 fi
297
298 # 4. Create a new interface to the bridge
299 new=$( ifconfig epair create ) || return
300 ifconfig "$iface$bridge" addm $new || return
301
302 # 5. Rename the new interface
303 ifconfig $new name "e${i}a_$name" || return
304 ifconfig ${new%a}b name "e${i}b_$name" || return
305 ifconfig "e${i}a_$name" up || return
306 ifconfig "e${i}b_$name" up || return
307
308 #
309 # 6. Set the MAC address of the new interface using a sensible
310 # algorithm to prevent conflicts on the network.
311 #
289 # 1. Make sure the interface doesn't exist already
290 ifconfig "e${i}a_$name" > /dev/null 2>&1 && continue
291
292 # 2. Bring the interface up
293 ifconfig $iface up || return
294
295 # 3. Make sure the interface has been bridged
296 if ! ifconfig "$iface$bridge" > /dev/null 2>&1; then
297 new=$( ifconfig bridge create ) || return
298 ifconfig $new addm $iface || return
299 ifconfig $new name "$iface$bridge" || return
300 ifconfig "$iface$bridge" up || return
301 fi
302
303 # 4. Create a new interface to the bridge
304 new=$( ifconfig epair create ) || return
305 ifconfig "$iface$bridge" addm $new || return
306
307 # 5. Rename the new interface
308 ifconfig $new name "e${i}a_$name" || return
309 ifconfig ${new%a}b name "e${i}b_$name" || return
310 ifconfig "e${i}a_$name" up || return
311 ifconfig "e${i}b_$name" up || return
312
313 #
314 # 6. Set the MAC address of the new interface using a sensible
315 # algorithm to prevent conflicts on the network.
316 #
312 derive_mac -2 $iface "$name" eiface_devid_a eiface_devid_b
313 ifconfig "e${i}a_$name" ether $eiface_devid_a > /dev/null 2>&1
314 ifconfig "e${i}b_$name" ether $eiface_devid_b > /dev/null 2>&1
317 eiface_devid_a= eiface_devid_b=
318 [ "$no_derive" ] || derive_mac -2 $iface "$name" \
319 eiface_devid_a eiface_devid_b
320 if [ "$eiface_devid_a" -a "$eiface_devid_b" ]; then
321 ifconfig "e${i}a_$name" ether $eiface_devid_a
322 ifconfig "e${i}b_$name" ether $eiface_devid_b
323 fi > /dev/null 2>&1
315
316 i=$(( $i + 1 )) # on to next e{i}b_name
317 done # for iface
318}
319
320jib_show_usage="show"
321jib_show_descr="List possible NAME values for \`show NAME'"
322jib_show1_usage="show NAME"
323jib_show1_descr="Lists e0b_NAME [e1b_NAME ...]"
324jib_show2_usage="show [NAME]"
325jib_show()
326{
327 local OPTIND=1 OPTARG flag
328 while getopts "" flag; do
329 case "$flag" in
330 *) action_usage show2 # NOTREACHED
331 esac
332 done
333 shift $(( $OPTIND - 1 ))
334 if [ $# -eq 0 ]; then
335 ifconfig | awk '
336 /^[^:[:space:]]+:/ {
337 iface = $1
338 sub(/:.*/, "", iface)
339 next
340 }
341 $1 == "groups:" {
342 for (n = split($0, group); n > 1; n--) {
343 if (group[n] != "bridge") continue
344 print iface
345 next
346 }
347 }' |
348 xargs -rn1 ifconfig |
349 awk '$1 == "member:" &&
350 sub(/^e[[:digit:]]+a_/, "", $2), $0 = $2' |
351 sort -u
352 return
353 fi
354 ifconfig | awk -v name="$1" '
355 match($0, /^e[[:digit:]]+a_/) && sub(/:.*/, "") &&
356 substr($1, RSTART + RLENGTH) == name
357 ' | sort
358}
359
360jib_destroy_usage="destroy NAME"
361jib_destroy_descr="Destroy e0b_NAME [e1b_NAME ...]"
362jib_destroy()
363{
364 local OPTIND=1 OPTARG flag
365 while getopts "" flag; do
366 case "$flag" in
367 *) action_usage destroy # NOTREACHED
368 esac
369 done
370 shift $(( $OPTIND -1 ))
371 local name="$1"
372 [ "${name:-x}" = "${name#*[!0-9a-zA-Z_]}" -a $# -eq 1 ] ||
373 action_usage destroy # NOTREACHED
374 mustberoot_to_continue
375 jib_show "$name" | xargs -rn1 -I eiface ifconfig eiface destroy
376}
377
378############################################################ MAIN
379
380#
381# Command-line arguments
382#
383action="$1"
384[ "$action" ] || usage # NOTREACHED
385
386#
387# Validate action argument
388#
389if [ "$BASH_VERSION" ]; then
390 type="$( type -t "jib_$action" )" || usage # NOTREACHED
391else
392 type="$( type "jib_$action" 2> /dev/null )" || usage # NOTREACHED
393fi
394case "$type" in
395*function)
396 shift 1 # action
397 eval "jib_$action" \"\$@\"
398 ;;
399*) usage # NOTREACHED
400esac
401
402################################################################################
403# END
404################################################################################
324
325 i=$(( $i + 1 )) # on to next e{i}b_name
326 done # for iface
327}
328
329jib_show_usage="show"
330jib_show_descr="List possible NAME values for \`show NAME'"
331jib_show1_usage="show NAME"
332jib_show1_descr="Lists e0b_NAME [e1b_NAME ...]"
333jib_show2_usage="show [NAME]"
334jib_show()
335{
336 local OPTIND=1 OPTARG flag
337 while getopts "" flag; do
338 case "$flag" in
339 *) action_usage show2 # NOTREACHED
340 esac
341 done
342 shift $(( $OPTIND - 1 ))
343 if [ $# -eq 0 ]; then
344 ifconfig | awk '
345 /^[^:[:space:]]+:/ {
346 iface = $1
347 sub(/:.*/, "", iface)
348 next
349 }
350 $1 == "groups:" {
351 for (n = split($0, group); n > 1; n--) {
352 if (group[n] != "bridge") continue
353 print iface
354 next
355 }
356 }' |
357 xargs -rn1 ifconfig |
358 awk '$1 == "member:" &&
359 sub(/^e[[:digit:]]+a_/, "", $2), $0 = $2' |
360 sort -u
361 return
362 fi
363 ifconfig | awk -v name="$1" '
364 match($0, /^e[[:digit:]]+a_/) && sub(/:.*/, "") &&
365 substr($1, RSTART + RLENGTH) == name
366 ' | sort
367}
368
369jib_destroy_usage="destroy NAME"
370jib_destroy_descr="Destroy e0b_NAME [e1b_NAME ...]"
371jib_destroy()
372{
373 local OPTIND=1 OPTARG flag
374 while getopts "" flag; do
375 case "$flag" in
376 *) action_usage destroy # NOTREACHED
377 esac
378 done
379 shift $(( $OPTIND -1 ))
380 local name="$1"
381 [ "${name:-x}" = "${name#*[!0-9a-zA-Z_]}" -a $# -eq 1 ] ||
382 action_usage destroy # NOTREACHED
383 mustberoot_to_continue
384 jib_show "$name" | xargs -rn1 -I eiface ifconfig eiface destroy
385}
386
387############################################################ MAIN
388
389#
390# Command-line arguments
391#
392action="$1"
393[ "$action" ] || usage # NOTREACHED
394
395#
396# Validate action argument
397#
398if [ "$BASH_VERSION" ]; then
399 type="$( type -t "jib_$action" )" || usage # NOTREACHED
400else
401 type="$( type "jib_$action" 2> /dev/null )" || usage # NOTREACHED
402fi
403case "$type" in
404*function)
405 shift 1 # action
406 eval "jib_$action" \"\$@\"
407 ;;
408*) usage # NOTREACHED
409esac
410
411################################################################################
412# END
413################################################################################